-- Created by hey @ Widow / icheat@lan
-- Licensed under the GNU General Public License Version 3.  See http://www.gnu.org/licenses/gpl-3.0.txt for details.
require "Apollo"
require "GameLib"
require "CostumesLib"
require "HousingLib"
require "Item"
require "Costume"

local DyeDummy = {}
DyeDummy.__index = DyeDummy

local form_doc
local form
local options_form

local dyes

local all_buttons
local slot_buttons

local current_dye_index = 1
local current_dye
local dye_entry_to_index = {}
local shown_dyes = {}

local options = {
  ["ShowUnknown"] = false
}

local preview_slots = {
  GameLib.CodeEnumItemSlots.Head,   GameLib.CodeEnumItemSlots.Shoulder, GameLib.CodeEnumItemSlots.Chest,
  GameLib.CodeEnumItemSlots.Hands,  GameLib.CodeEnumItemSlots.Legs,     GameLib.CodeEnumItemSlots.Feet
}

function DyeDummy.new()
  local self = setmetatable({}, DyeDummy)

  return self
end

function DyeDummy:Init()
  Apollo.RegisterAddon(self)
  self.nDisplayedCostumeId = CostumesLib.GetCostumeIndex()
  self.costumeDisplayed = CostumesLib.GetCostume(self.nDisplayedCostumeId)
  self.unitPlayer = GameLib.GetPlayerUnit()
end

function DyeDummy:OnLoad()
  Apollo.RegisterSlashCommand("dd", "OnSlashCommand", self)
  Apollo.RegisterSlashCommand("dyedummy", "OnSlashCommand", self)

  form_doc = XmlDoc.CreateFromFile("DyeDummy.xml")
  form = Apollo.LoadForm(form_doc, "DyeDummyWindow", nil, self)

  options_form = Apollo.LoadForm(form_doc, "OptionsWindow", form, self)

  local lang = "EN"
  local l_test = Apollo.GetString(1)
  if l_test == "Abbrechen" then
    lang = "DE"
  elseif l_test == "Annuler" then
    lang = "FR"
  end

  -- thanks Sinaloit
  dyes = dofile(string.match(Apollo.GetAssetFolder(), "(.-)[\\/][Aa][Dd][Dd][Oo][Nn][Ss]") .. "\\Addons\\DyeDummy\\Dyes-" .. lang .. ".lua")

  -- pax this needs to be setup before had, otherwise the sheathing and unsheathoing of weapon seems a bit clanky - 3/07/2015
  form:FindChild("CostumePreview:ToggleSheath"):SetCheck(true)
  form:FindChild("DyeContainer:txtbxVersion"):SetText("v1")
  form:FindChild("CostumePreview"):SetSheathed(form:FindChild("CostumePreview:ToggleSheath"):IsChecked())
	
  

end

function DyeDummy:OnSave(level)
  if level ~= GameLib.CodeEnumAddonSaveLevel.Account then
    return nil
  end

  return options
end

function DyeDummy:OnRestore(level, save)
  if level ~= GameLib.CodeEnumAddonSaveLevel.Account then
    return nil
  end

  options = save
end

function DyeDummy:OnClose(_, _, _)
  form:Show(false)  
end

function DyeDummy:OnShowOptionsWindow(_, _, _)
  options_form:Show(true)
  options_form:FindChild("OShowUnknown"):SetCheck(options.ShowUnknown)
end

function DyeDummy:OnCloseOptionsWindow(_, _, _)
  options_form:Show(false)
end

---------------------------------------------------------------------------------------------------
-- DyeDummyWindow Functions
---------------------------------------------------------------------------------------------------
function DyeDummy:OnToggleShowUnknown(_, control, _)
  options.ShowUnknown = control:IsChecked()

  self:BuildDyeList(form:FindChild("DyeContainer:DyeSelectorWindow:FilterKnownDyes"):IsChecked())
  form:FindChild("DyeContainer:DyeSelectorWindow:FilterUnknownDyes"):SetCheck(false)
  form:FindChild("DyeSearchBox"):SetText("")
end

function DyeDummy:OnToggleShowKnown(_, control, _)
  self:BuildDyeList(control:IsChecked())
  form:FindChild("DyeContainer:DyeSelectorWindow:FilterUnknownDyes"):SetCheck(false)
  form:FindChild("DyeSearchBox"):SetText("")
end

function DyeDummy:OnToggleShowDontKnown( wndHandler, wndControl, eMouseButton )
	self:BuildDyeListforUnknownDyes(wndControl:IsChecked())
		
	form:FindChild("DyeContainer:DyeSelectorWindow:FilterKnownDyes"):SetCheck(false)
	form:FindChild("DyeSearchBox"):SetText("")
end

function DyeDummy:OnToggleShowDontKnownOff( wndHandler, wndControl, eMouseButton )
	self:BuildDyeList(false)
	form:FindChild("DyeSearchBox"):SetText("")
end

function DyeDummy:BuildDyeList(only_known)
  local dye_list = form:FindChild("DyeContainer:DyeSelectorWindow:DyeSearchList")
  dye_list:DestroyChildren()
  dye_entry_to_index = {}

  local known_dyes = {}
  for _, dye in ipairs(GameLib.GetKnownDyes()) do
    known_dyes[dye.nId] = true
  end

  for idx, dye in ipairs(dyes) do
    if dye[4] ~= "(Unnamed)" or options.ShowUnknown then
      if not only_known or known_dyes[dye[1]] then
        local entry = Apollo.LoadForm(form_doc, "DyeListEntry", dye_list, self)

		if dye[4] == "Maris Blue" then 
			dye[4] = "Cobalt Blue"
		end
		
        entry:FindChild("DyeName"):SetText(dye[4])
        entry:FindChild("SwatchContainer:DyeSwatch"):SetSprite("CRB_DyeRampSprites:sprDyeRamp_" .. dye[2])
        entry:SetData(dye)

        dye_entry_to_index[dye[1]] = idx

        if idx == 2 then -- XXX: temporary
          current_dye = dye
          current_dye_index = 2
          entry:SetCheck(true)
          form:FindChild("DyeContainer:DyeSelection"):SetText(entry:FindChild("DyeName"):GetText())
        end
      end
    end
  end -- for idx

  dye_list:ArrangeChildrenVert()
end

function DyeDummy:BuildDyeListforUnknownDyes(only_unknown)
  local dye_list = form:FindChild("DyeContainer:DyeSelectorWindow:DyeSearchList")
  dye_list:DestroyChildren()
  dye_entry_to_index = {}

  local known_dyes = {}
  for _, dye in ipairs(GameLib.GetKnownDyes()) do
    known_dyes[dye.nId] = true
  end

  for idx, dye in ipairs(dyes) do
    if dye[4] == "(Unnamed)" then

    --Print(string.format("%s",tostring(dye[4])))  
	
	if only_unknown  then
        local entry = Apollo.LoadForm(form_doc, "DyeListEntry", dye_list, self)
		
        entry:FindChild("DyeName"):SetText(dye[4])
        entry:FindChild("SwatchContainer:DyeSwatch"):SetSprite("CRB_DyeRampSprites:sprDyeRamp_" .. dye[2])
        entry:SetData(dye)

        dye_entry_to_index[dye[1]] = idx

        if idx == 2 then -- XXX: temporary
          current_dye = dye
          current_dye_index = 2
          entry:SetCheck(true)
          form:FindChild("DyeContainer:DyeSelection"):SetText(entry:FindChild("DyeName"):GetText())
        end
      end
    end
  end -- for idx

  dye_list:ArrangeChildrenVert()
end


function DyeDummy:OnSlashCommand()
  form:Show(not form:IsVisible())

  if form:IsVisible() then
    local unit = GameLib.GetPlayerUnit()

    form:FindChild("CostumePreview"):SetCostume(unit)

    if not slot_buttons then
      self:AggregateButtons()
      self:BuildDyeList(false)
    end

    self:UpdateChannelAvailability()
  end
end

function DyeDummy:GetPreviewItems()
  --local costume = self.nDisplayedCostumeId --CostumesLib.GetCostumeIndex() --1 --GameLib.GetCostumeIndex()
  local equipped = {}
  local items = {}
  local visibility = {}
 -- local mannequin = CostumesLib.GetCostume(costume)


-- want to iterate through each slot of the curent manequin and set the check boxes to do something or not

	for k, v in ipairs(preview_slots) do
		if self.nDisplayedCostumeId > 0 then
			if self.costumeDisplayed:GetSlotItem(v) ~= nil then
				visibility[v] = self.costumeDisplayed:IsSlotVisible(v)
				items[v] = self.costumeDisplayed:GetSlotItem(v)
			else
				visibility[v] = false
				items[v] = nil
			end
		end --if costume
		
	end -- for k
		    
				
	--for _, slotIndex in GameLib.CodeEnumItemSlots do
	--   slotcontents = mannequin:GetSlotItem(slotIndex)

     --  equipped[slotindex] = slotcontents

    --	if costume == 0 then
     --  		items[slot] = slotcontent
      -- 		visibility[slotIndex] = not not slotcontent
   -- 	end -- if costume = 0

	--	if costume > 0 then
		
			
	--	end -- if costume > 0
  	--end -- for


--  for _, item in ipairs(Costume) do --GameLib.GetPlayerUnit():GetEquippedItems()) do
--    local slot = item:GetSlot() + 1
--    equipped[slot] = Item

--    if costume == 0 then
 --     items[slot] = item
 --     visibility[slot] = not not item
 --   end -- if
 -- end -- for


--  if costume > 0 then
  --  for _, slot in ipairs(preview_slots)
--preview_slots) do --ipairs(preview_slots) do
  --    local item = Costume:GetSlotItem(slot) -- GameLib.GetCostumeItem(costume, slot) changed by pax 
		
	--  Print("Slot = %S",toString(slot))
	
	  --visibility[slot] = Costume:IsSlotVisible(slot)
	
	 -- visibility[slot] = GameLib.IsCostumeSlotVisible(costume, slot)

      --if not item and visibility[slot] then
       -- item = equipped[slot]
      --end

      --items[slot] = item
    --end -- for
  --end -- if costume > 0



  return items, visibility
end

function DyeDummy:UpdateCostumeDye()
  local items, visibility = self:GetPreviewItems()
  local wnd = form:FindChild("CostumePreview")

-- local preview_slots = {
--  GameLib.CodeEnumItemSlots.Head(3),   GameLib.CodeEnumItemSlots.Shoulder(4), GameLib.CodeEnumItemSlots.Chest(1),
--  GameLib.CodeEnumItemSlots.Hands(6),  GameLib.CodeEnumItemSlots.Legs(2),     GameLib.CodeEnumItemSlots.Feet(5)
-- }

-- slot 3 = head
-- slot 4 = shoulders
-- slot 1 = chest
-- slot 6 = hands
-- slot 2 = legs
-- slot 5 = feet

-----------------------------
-- slot_idx values tested
-----------------------------
-- iteration   value
--    1          3
--    2          4
--    3          1
--    4          6
--    5          2
--    6          5
-----------------------------
--	for k, v in pairs(shown_dyes) do
--		Print(string.format('%s %s %s',v[1],v[2],v[3]))
--	end -- for k
	--for k, v in pairs(slot_buttons) do
--		Print(v[1]:GetData())-
--	end -- for k
	local iter = 1
	local s = ''
	for _, slot_idx in ipairs(preview_slots) do
		
		if slot_idx ~= nil then
		--	Print(string.format('Iteration:%s result:%s',tostring(iter), tostring(slot_idx)))
			s = "CostumeSlot" .. slot_idx
		--	Print(s)
			
			local slot = wnd:FindChild(s)
			
			for i =1, 3 do
				if slot_buttons[slot_idx][i]:IsChecked() then
					shown_dyes[slot_idx][i] = current_dye[1]
					--Print(string.format('enabled slot %s',slot_buttons[slot_idx][1]:GetName()))
				else
					shown_dyes[slot_idx][i] = 0
				end
			end
						
	 	end -- try to capture a nil in slot_idx
	
	
	-- so now update the mannequi with the cuurent selected dye
	--wnd:SetItemDye(items[slot_idx], shown_dyes[slot_idx][1], shown_dyes[slot_idx][2], shown_dyes[slot_idx][3] )
		if items[slot_idx] ~= nil then
			local coldyes = {0,0,0}
			for x=1, 3 do
				if shown_dyes[slot_idx][x] ~= nil then
					coldyes[x] = shown_dyes[slot_idx][x]
				end
			end -- for
		--```    Print("SetItemDye for iteration" .. iter)
			wnd:SetItemDye(items[slot_idx], coldyes[1], coldyes[2], coldyes[3])
		end
	iter = iter + 1
	end -- for slot_idx
	
end -- function
		



function randomness()
		
for _, slot_idx in ipairs(preview_slots) do

		
   local slot = container:FindChild("CostumeSlot" .. tostring(slot_idx))

    slot:SetData(slot_idx)

    slot_buttons[slot_idx] = {
      slot:FindChild("Color1"),
      slot:FindChild("Color2"),
      slot:FindChild("Color3")
    }

    shown_dyes[slot_idx] = { 0, 0, 0 }

    for i = 1, 3 do
		if  slot_buttons[slot_idx][i] ~= nil then
			if slot_buttons[slot_idx][i]:IsEnabled() and slot_buttons[slot_idx][i]:IsChecked() then
	  			shown[i] = shown_dyes[i]
			end
			if slot_buttons[slot_idx][i]:IsEnabled() and slot_buttons[slot_idx][i]:IsChecked() ~= true then
				shown[i] = Costume:GetSlotDyes(slot_idx)[i]
			end -- if slot_butts
		end -- if slot
    end -- for i
	
 end -- for slot_idx


    for slot, buttons in pairs(slot_buttons) do
       local shown = shown_dyes[slot]
       for i = 1, 3 do
          shown[i] = (buttons[i]:IsEnabled() and buttons[i]:IsChecked()) and current_dye[1] or shown_dyes[slot][i]
       end -- for i

       if items[slot] and visibility[slot] then
         wnd:SetItemDye(items[slot], shown[1], shown[2], shown[3])
       end -- if items
    end -- for slot
end -- funtction
--*********************************************
--local cr = {}
--for _, slot_idx in pairs(slot_buttons) do
--	for i = 1, 3 do
--		if (buttons[slot_idx]:IsEnabled() and buttons[slot_idx]:IsChecked()) then
--			shown_dyes[slot_idx][i] =  current_dye[slot_idx][i]
--		else
			
--		end
--	end -- for i
--****************************************
  --  wnd:SetItemDye(items[slot_idx], redisplayshown[1], redisplayshown[2], redisplayshown[3])  -
--	Print( tostring(slot_idx) )
--end -- for slot

-- shown[GameLib.CodeEnumItemSlots.Head] = (buttons[1]:IsEnabled() and buttons[1]:IsChecked()) and current_dye[GameLib.CodeEnumItemSlots.Head] or shown_dyes[GameLib.CodeEnumItemSlots.Head]
-- wnd:SetItemDye(items[GameLib.CodeEnumItemSlots.Head], shown[GameLib.CodeEnumItemSlots.Head])

--  for _, slot in ipairs(preview_slots) do
	--shown[slot] = (buttons[slot]:IsEnabled() and buttons[slot]:IsChecked()) and current_dye[slot] or shown_dyes[slot][slot]
	--if buttons[slot.index]:IsEnabled() then
--		if buttons[slot+1]:IsChecked() then
--			shown[slot+1] = current_dye[slot+1]
--		else
--		    shown[slot+1] = shown_dyes[slot+1]
--		end
--	else
--	end
	--shown[slot] = current_dye[slot] or shown_dyes[slot][slot]
--	if shown[slot+1] ~= nil then	
		--	Print(tostring(string.format('%s %s',slot + 1, shown[slot+1])))
--	end
  --end -- _'


 -- for slot, buttons in pairs(slot_buttons) do
 --   local shown = shown_dyes[slot]

--	if slot == 1 then
--		for i = 1, 3 do
  -- 	 	  shown[i] = (buttons[i]:IsEnabled() and buttons[i]:IsChecked()) and current_dye[i] or shown_dyes[slot][i]
  	-- 	end -- for i
	  --  wnd:SetItemDye(items[slot], shown[i])

	--else
	 --  local redisplayshown ={}
 	  -- if items[slot] and visibility[slot] then
		--	for i = 1, 3 do	
		
		--	shown[i] = (buttons[i]:IsEnabled() and buttons[i]:IsChecked()) and current_dye[i] or shown_dyes[slot][i]
		
		  --		if (buttons[i]:IsEnabled() and buttons[i]:IsChecked()) then
			--		if shown[i] ~= nil then
			--			redisplayshown[i] = shown[i]
			--		else
			--			redisplayshown[i] = 0
			--		end
	  		--	else
			--			redisplayshown[i] = 0
	  		--	end
	--		end
	--	end
		--wnd:SetItemDye(items[slot], redisplayshown[1], redisplayshown[2], redisplayshown[3])

   -- end
--	  end -- for slot
  


function DyeDummy:AggregateButtons()
  all_buttons = {}
  slot_buttons = {}

  local container = form:FindChild("DyeContainer")

  local all_slot_buttons = container:FindChild("AllSlotsContainer"):GetChildren()
  for i = 1, 3 do
    all_buttons[i] = all_slot_buttons[i]
    all_buttons[i]:SetData(i)
  end

  for _, slot_idx in ipairs(preview_slots) do
    local slot = container:FindChild("CostumeSlot" .. tostring(slot_idx))

    slot:SetData(slot_idx)

    slot_buttons[slot_idx] = {
      slot:FindChild("Color1"),
      slot:FindChild("Color2"),
      slot:FindChild("Color3")
    }

    shown_dyes[slot_idx] = { 0, 0, 0 }

    for i = 1, 3 do
      slot_buttons[slot_idx][i]:SetData(i)
    end
  end
end

function DyeDummy:UpdateChannelAvailability()
  local items, visibility = self:GetPreviewItems()

  for slot, buttons in pairs(slot_buttons) do
    if items[slot] and visibility[slot] then
      local channels = items[slot]:GetAvailableDyeChannel()
      buttons[1]:Enable(channels.bDyeChannel1)
      buttons[2]:Enable(channels.bDyeChannel2)
      buttons[3]:Enable(channels.bDyeChannel3)
    else
      for i = 1, 3 do
        buttons[i]:Enable(false)
      end
    end
  end
end

function DyeDummy:FilterDyeList(term)
  local list = form:FindChild("DyeContainer:DyeSelectorWindow:DyeSearchList")
  for _, entry in ipairs(list:GetChildren()) do
    local matches = not not string.find(string.lower(entry:FindChild("DyeName"):GetText()), string.lower(term), 1, true)
    entry:Show(matches)
    entry:Enable(matches)
  end

  list:ArrangeChildrenVert()
end

function DyeDummy:OnDyeListEntry(_, control, _)
  form:FindChild("DyeContainer:DyeSelection"):SetText(control:FindChild("DyeName"):GetText())

  current_dye = control:GetData()
  current_dye_index = dye_entry_to_index[control:GetData()[1]]

  self:UpdateCostumeDye()
end

function DyeDummy:OnDyeSelectionToggle(_, control, _)
  control:GetParent():FindChild("DyeSelectorWindow"):Show(control:IsChecked())
end

function DyeDummy:OnColorChannelToggle(_, control, _)
  local slot_idx = control:GetParent():GetData()

  all_buttons[control:GetData()]:SetCheck(false)

  self:UpdateCostumeDye()
end

function DyeDummy:OnPreviousDye(_, _, _)
  local dye_entries = form:FindChild("DyeContainer:DyeSelectorWindow:DyeSearchList"):GetChildren()

  local next_index = current_dye_index - 1
  while next_index > 0 and not dye_entries[next_index]:IsEnabled() do
    next_index = next_index - 1
  end

  if next_index ~= 0 then
    current_dye_index = next_index

    for idx, button in ipairs(dye_entries) do
      button:SetCheck(idx == current_dye_index)

      if idx == current_dye_index then
        current_dye = button:GetData()
        form:FindChild("DyeContainer:DyeSelection"):SetText(button:FindChild("DyeName"):GetText())
      end
    end

    self:UpdateCostumeDye()
  end
end

function DyeDummy:OnNextDye(_, _, _)
  local dye_entries = form:FindChild("DyeContainer:DyeSelectorWindow:DyeSearchList"):GetChildren()

  local next_index = current_dye_index + 1
  while next_index <= #dye_entries and not dye_entries[next_index]:IsEnabled() do
    next_index = next_index + 1
  end

  if next_index <= #dye_entries then
    current_dye_index = next_index

    for idx, button in ipairs(dye_entries) do
      button:SetCheck(idx == current_dye_index)

      if idx == current_dye_index then
        current_dye = button:GetData()
        form:FindChild("DyeContainer:DyeSelection"):SetText(button:FindChild("DyeName"):GetText())
      end
    end

    self:UpdateCostumeDye()
  end
end

function DyeDummy:ClearButtons()
  for _, b in ipairs(all_buttons) do
    b:SetCheck(false)
  end

  for _, buttons in ipairs(slot_buttons) do
    for _, b in ipairs(buttons) do
      b:SetCheck(false)
    end
  end
	 self:UpdateCostumeDye()
end

function DyeDummy:OnApply(_, _, _)
  self:ClearButtons()
end

function DyeDummy:OnReset(_, _, _)
  self:ClearButtons()

  for idx, _ in ipairs(shown_dyes) do
	--if Costume:GetSlotDyes(GameLib.CodeEnumItemSlots[idx]) == nil then
		shown_dyes[idx] = { 0, 0, 0 }
	--else
	--	shown_dyes[idx] = Costume:GetSlotDyes(GameLib.CodeEnumItemSlots[idx])
	--end
  end

  self:UpdateCostumeDye()
end

function DyeDummy:OnAllToggle(_, control, _)
  for slot_idx, buttons in pairs(slot_buttons) do
    buttons[control:GetData()]:SetCheck(control:IsChecked())
  end

  self:UpdateCostumeDye()
end


function DyeDummy:OnClearSearchTerm(_, control, _)
  local box = control:GetParent():FindChild("DyeSearchBox")
  box:SetText("")
  box:ClearFocus()

  self:FilterDyeList("")
end

function DyeDummy:OnSearchTermChanged(_, control, _)
  self:FilterDyeList(control:GetText())
end

function DyeDummy:OnRotateLeft(_, _, _)
  form:FindChild("CostumePreview"):ToggleLeftSpin(true)
end

function DyeDummy:OnEndRotateLeft(_, _, _)
  form:FindChild("CostumePreview"):ToggleLeftSpin(false)
end

function DyeDummy:OnRotateRight(_, _, _)
  form:FindChild("CostumePreview"):ToggleRightSpin(true)
end

function DyeDummy:OnEndRotateRight(_, _, _)
  form:FindChild("CostumePreview"):ToggleRightSpin(false)
end

function DyeDummy:OnToggleSheath(_, control, _)
  form:FindChild("CostumePreview"):SetSheathed(control:IsChecked())
end


function DyeDummy:OnShow( wndHandler, wndControl )
  self.nDisplayedCostumeId = CostumesLib.GetCostumeIndex()
  self.costumeDisplayed = CostumesLib.GetCostume(self.nDisplayedCostumeId)
  self.unitPlayer = GameLib.GetPlayerUnit()
end


DyeDummy.new():Init()





